from jinja2 import Environment, FileSystemLoader, select_autoescape
import yaml
import pyinotify
import asyncore
import time

def get_memes():
    manifest = '/home/ldm/public_html/memes.yaml'
    with open(manifest) as fd:
        memes = yaml.load(fd.read())
        return memes # just to make sure this is a list I guess

env = Environment(
    loader=FileSystemLoader('/home/ldm/public_html/templates'),
    autoescape=select_autoescape(['html','xml'])
)



def rewrite():
    template = env.get_template('memes.html')
    print(get_memes())
    with open("/home/ldm/public_html/index.html", "w") as fd:
        fd.write(template.render(memes=get_memes()))

class EventHandler(pyinotify.ProcessEvent):
    def my_init(self):
        pass

    def process_default(self, event):
        if (event.mask & (pyinotify.IN_DELETE | pyinotify.IN_DELETE | pyinotify.IN_MODIFY) and 
            not  event.path.endswith("public_html/index.html")):     
            print("Rewritten (", event.pathname, ")", time.time())
        

def main():
    print("Started script!")
    rewrite()
    watch = pyinotify.WatchManager()
    watch.add_watch('/home/ldm/public_html/', pyinotify.ALL_EVENTS)
    watch.add_watch('/home/ldm/public_html/templates/', pyinotify.ALL_EVENTS)
    notify = pyinotify.AsyncNotifier(watch, EventHandler())    
    asyncore.loop() # uh this appears to do it but it's py2 so uuhhhh
    

if __name__ == "__main__":
    main()




    